package edBlacklist
{
	function WrenchImage::OnFire(%this, %player, %slot)
	{
		if(%player.client.edBlacklisted)
		{
			centerPrint(%player.client, "You are blacklisted and cannot use the wrench.", 5);
			return;
		}
		parent::onFire(%this, %player, %slot);
	}
	function serverCmdPlantBrick(%client)
	{
		if(%client.edBlacklisted)
		{
			centerPrint(%client, "You are blacklisted and cannot build.", 5);
			return;
		}
		parent::serverCmdPlantBrick(%client);
	}
	function serverCmdEditBlacklistPlayer(%client, %target)
	{
		%obj = findClientByname(%target);
		if((%client.isHost && !%obj.edBlacklisted) || (%client.isHost && !$EdBlacklist.lookFor[%target]))
		{
			if(isObject(%obj))
			{
				%obj.edBlacklisted = 1;
				$EdBlacklist.lookFor[%obj.getPlayerName()] = 1;
				$EdBlacklist.str = $EdBlacklist.str NL %obj.getPlayerName();
				%client.chatMessage("\c6You have blacklisted \c3"@%obj.getPlayerName()@"\c6.");
			}
			else
			{
				$EdBlacklist.lookFor[%target] = 1;
				$EdBlacklist.str = $EdBlacklist.str NL %target;
				%client.chatMessage("\c6You have blacklisted \c3"@%target@"\c6.");
			}
			updateBlacklistFile();
		}
	}
	function serverCmdUnEditBlacklistPlayer(%client, %target)
	{
		%obj = findClientByname(%target);
		if((%client.isHost && %obj.edBlacklisted) || (%client.isHost && $EdBlacklist.lookFor[%target]))
		{
			if(isObject(%obj))
			{
				%obj.edBlacklisted = 0;
				$EdBlacklist.lookFor[%obj.getPlayerName()] = 0;
				$EdBlacklist.str = trim(strReplace($EdBlacklist.str, %obj.getPlayerName(), ""));
				%client.chatMessage("\c6You have un-blacklisted \c3"@%obj.getPlayerName()@"\c6.");
			}
			else
			{
				$EdBlacklist.lookFor[%target] = 0;
				$EdBlacklist.str = trim(strReplace($EdBlacklist.str, %target, ""));
				%client.chatMessage("\c6You have un-blacklisted \c3"@%target@"\c6.");
			}
			updateBlacklistFile();
		}
	}
	function startgame()
	{
		parent::startgame();
		schedule(33,0,initEdBlacklist);
	}
	function initEdBlacklist()
	{
		if(!isObject($EdBlacklist))
			$EdBlacklist = new scriptObject(edBlacklist);
		loadBlacklistFile();
	}
	function gameConnection::onClientEnterGame(%client)
	{
		parent::onClientEnterGame(%client);
		if($EdBlacklist.lookFor[%client.getPlayerName()] || striPos($EdBlacklist.str, %client.getPlayerName()) != -1)
		{
			%client.edBlacklisted = 1;
			messageClient(%client,'',"\c3You have been automatically blacklisted.");
		}
	}
	function serverCmdListEditBlacklisted(%client)
	{
		if(%client.isHost)
			centerPrint(%client, "<just:left>\c3"@$EdBlacklist.str, 7);
	}

	function updateBlacklistFile()
	{
		%file = new fileObject();
		%file.openForWrite("config/server/editBlacklist.txt");
		for(%i = 0; %i < getWordCount($EdBlacklist.str); %i++)
			%file.writeLine(getWord($EdBlacklist.str, %i));
		%file.close();
		%file.delete();
	}

	function loadBlacklistFile()
	{
		%file = new fileObject();
		%file.openForRead("config/server/editBlacklist.txt");
		while(!%file.isEOF())
		{
			%line = %file.readLine();
			$EdBlacklist.lookFor[%line] = 1;
			$EdBlacklist.str = $EdBlacklist.str NL %line;
			if(isObject(findClientByName(%line)))
				findClientByName(%line).edBlacklisted = 1;
		}
		%file.close();
		%file.delete();
	}
};
activatePackage(edBlacklist);

function serverCmdEnableEditBlacklist(%client)
{
	if(%client.isHost)
	{
		activatePackage(edBlacklist);
		chatmessageAll("\c3"@%client.getPlayerName()@"\c6 has enabled the edit blacklist.");
	}
}

function serverCmdDisableEditBlacklist(%client)
{
	if(%client.isHost)
	{
		deactivatePackage(edBlacklist);
		chatmessageAll("\c3"@%client.getPlayerName()@"\c6 has disabled the edit blacklist.");
	}
}

package isHost //Thanks, Truce! :D
{
	function GameConnection::autoAdminCheck(%this)
	{
		%this.isHost = (%this.isLocalConnection() || %this.bl_id == getNumKeyID());
		return Parent::autoAdminCheck(%this);
	}
};
activatePackage(isHost);